<template>
	<view class="bg-fff item" @click="toDetail">
		<view class="u-flex u-p-b-22 border-bottom  u-row-between u-col-center">
			<view class="u-flex   u-col-bottom">
				<template v-if="data.tableName">
					<view class="u-flex u-col-center">
						<view class="u-font-40 color-333">{{data.tableName}}</view>
						<view class="line" style="height: 16px;"></view>
					</view>
				</template>
				<view class="">{{data.masterId}}</view>
			</view>
			<view class="u-flex">
				<view>
					<text :class="[data.status]">{{returnStatus(data.status)}}</text>
				</view>
				<view class="line"></view>
				<view class="  color-main">
					<text>
						{{sendTypeFilter(data.sendType)}}
					</text>
				</view>
			</view>
		</view>
		<view class="u-m-t-26">
			<view class="u-flex u-col-bottom u-font-24 color-999">
				<up-avatar :size="33"></up-avatar>
				<view class="u-m-l-16">{{formatTime(data.createdAt)}}</view>
			</view>
			<view class="u-m-t-32">
				<view class="u-font-32">{{goosZhonglei}}种商品，共{{goodsNumber}}件</view>
				<view class="border-bottom u-p-b-32">
					<view class="u-flex u-row-between u-col-top u-m-t-32" v-for="(item,index) in data.detailList"
						:key="index">
						<view>
							<view class=""> {{item.productName}}</view>
							<view class="color-999 u-font-24 u-m-t-8">
								{{item.productSkuName}}
							</view>
						</view>
						<view class="u-flex u-flex-1 u-row-right">
							<view>×{{item.num}}</view>
							<view class="u-text-right" :style="computedPriceStyle()">￥{{item.price}}</view>
						</view>
					</view>
				</view>

			</view>
			<view class="u-flex u-row-between border-bottom u-m-t-32 u-p-b-32 u-col-top">
				<view class="no-wrap u-m-r-32">订单备注</view>
				<view>{{data.remark||'无'}}</view>
			</view>
			<view class="u-m-t-32">
				<view class="u-flex u-row-right">
					<text>小计￥</text>
					<text class="font-bold u-font-32">{{data.orderAmount}}</text>
				</view>
				<view class="u-flex u-row-right u-m-t-24">
					<view class="print" @click.stop="print(item)">重新打印</view>
				</view>
			</view>
		</view>
	</view>
</template>

<script setup>
	import dayjs from 'dayjs';
	import orderEnum from '@/commons/orderEnum.js'
	import go from '@/commons/utils/go.js'
	import {
		computed,
		reactive,
		ref,
		watch
	} from 'vue';
	const emits = defineEmits(['printOrder'])
	const props = defineProps({
		data: {
			type: Object,
			default: () => {
				detailList: []
			}
		},
		index: {
			type: [String, Number],
			default: 0
		}
	})
	let $goodsMap = {}
	let goosZhonglei = ref(0)
	let goodsNumber = ref(0)

	const priceSize = 9

	function computedPriceStyle() {
		const item = props.data.detailList.reduce((prev, current) => (`${prev.price}`.length > `${current.price}`
			.length) ? prev : current)
		if (!item) {
			return ''
		}
		const minW=`${item.price}`.length * priceSize + 15
		return {
			'min-width':(minW<36?36:minW) + 'px'
		}
	}
	// const computedPriceStyle = computed(() => {

	// })

	function goodsMapInit() {
		for (let i in props.data.detailList) {
			const goods = props.data.detailList[i]
			if ($goodsMap.hasOwnProperty(goods.productId)) {
				$goodsMap[goods.productId] += goods.num * 1
				goodsNumber.value += goods.num * 1
			} else {
				$goodsMap[goods.productId] = goods.num * 1
				goosZhonglei.value += 1
				goodsNumber.value += goods.num * 1
			}
		}
	}
	goodsMapInit()
	watch(() => props.data.detailList.length, (newval) => {
		goodsNumber.value = 0
		goodsMapInit()
	})


	function formatTime(time) {
		return dayjs(time).format('YYYY-MM-DD HH:mm:ss');
	}

	function returnStatus(status) {
		const item = orderEnum.status.find(v => v.key == status)
		return item ? item.label : ''
	}

	function sendTypeFilter(t) {
		console.log(t);
		if (t) {
			const item = orderEnum.sendType.find(item => item.key == t)
			return item ? item.label : '';
		} else {
			return t;
		}
	}

	function toDetail() {
		go.to('PAGES_ORDER_DETAIL', {
			id: props.data.id
		})
	}

	function print(item) {
		emits('printOrder', props.data)
	}
</script>

<style lang="scss" scoped>
	.border-bottom {
		border-bottom: 1rpx solid #E5E5E5;
	}

	.u-font-40 {
		font-size: 40rpx;
	}

	.item {
		padding: 16rpx 24rpx 32rpx 24rpx;
		border-radius: 18rpx 18rpx 18rpx 18rpx;
		margin-bottom: 32rpx;
	}

	.unpaid {
		color: #FD7B49;
	}

	.print {
		padding: 6rpx 14rpx 8rpx 18rpx;
		border: 1px solid $my-main-color;
		color: $my-main-color;
		font-size: 24rpx;
		border-radius: 100rpx;
	}

	.line {
		height: 14px;
		width: 1px;
		background-color: #E5E5E5;
		margin: 0 12rpx;
	}

	.row {
		.top {
			display: flex;

			.name {
				width: 50%;
			}

			.num {
				width: 20%;
				display: flex;
				justify-content: flex-end;
			}

			.price {
				width: 30%;
				display: flex;
				justify-content: flex-end;
			}
		}
	}
</style>